const formatTime = date => {
	const year = date.getFullYear()
	const month = date.getMonth() + 1
	const day = date.getDate()
	const hour = date.getHours()
	const minute = date.getMinutes()
	const second = date.getSeconds()

	return [year, month, day].map(formatNumber).join('/') + ' ' + [hour, minute, second].map(formatNumber).join(':')
}

const formatNumber = n => {
	n = n.toString()
	return n[1] ? n : '0' + n
}

// 格式化时间// 20180101101010  => 2018-01-01 10:10:10
function formatDate(time) {
	return `${time.substring(8, 10)}:${time.substring(10, 12)}`
}
/** 检测是否有定位权限BY 小程序 **/
function checkHasLocationPermissionByMP() {
	return new Promise(function (resolve, reject) {
		wx.getSetting({
			success(sd) {
				if (!sd.authSetting['scope.userLocation']) {
					wx.authorize({
						scope: 'scope.userLocation',
						success(e) {
							resolve(e)
						},
						fail(e) {
							reject()
						}
					})
				} else {
					resolve(sd)
				}
			}
		})
	})
}
function picInit(value) {
	let baseUrl = "../../static/images/"
	value = value || '';
	return baseUrl + "room.png"
	if (value.startsWith("300") || value.startsWith("310") || value.startsWith("311")) {
		return baseUrl + "ic311.png"
	} else if (value.startsWith("312")) {
		return baseUrl + "ic312.png"
	} else if (value.startsWith("313")) {
		return baseUrl + "ic313.png"
	} else if (value.startsWith("314")) {
		return baseUrl + "ic314.png"
	} else if (value.startsWith("315")) {
		return baseUrl + "ic315.png"
	} else if (value.startsWith("320") || value.startsWith("321")) {
		return baseUrl + "ic321.png"
	} else if (value.startsWith("322")) {
		return baseUrl + "ic322.png"
	} else if (value.startsWith("323")) {
		return baseUrl + "ic323.png"
	} else if (value.startsWith("33")) {
		return baseUrl + "ic331.png"
	} else {
		return baseUrl + "ic313.png"
	}
}
// 前面补零
function PrefixZero(num, n = 2) {
	return (Array(n).join(0) + num).slice(-n);
}
function formatMsgTime(dateStr) {
	// let dateObj = dateStr.replace(/T/g, ' ').replace(/\.[\d]{3}Z/, '').replace(/(-)/g, '/')
	let targetDate = new Date(dateStr);
	let year = targetDate.getFullYear();
	let month = targetDate.getMonth() + 1;
	let day = targetDate.getDate();
	let hour = targetDate.getHours();
	let minute = targetDate.getMinutes();
	// let second = targetDate.getSeconds();
	let nowDate = new Date();
	let now_new = Date.parse(nowDate.toString());
	let milliseconds = 0;
	let timeSpanStr;
	milliseconds = now_new - targetDate;
	if (milliseconds <= 1000 * 60 * 1) {
		timeSpanStr = '刚刚';
	}
	else if (1000 * 60 * 1 < milliseconds && milliseconds <= 1000 * 60 * 60) {
		timeSpanStr = Math.round((milliseconds / (1000 * 60))) + '分钟前';
	}
	else if (1000 * 60 * 60 * 1 < milliseconds && milliseconds <= 1000 * 60 * 60 * 24) {
		timeSpanStr = Math.round(milliseconds / (1000 * 60 * 60)) + '小时前';
	}
	else if (1000 * 60 * 60 * 24 < milliseconds && milliseconds <= 1000 * 60 * 60 * 24 * 15) {
		timeSpanStr = Math.round(milliseconds / (1000 * 60 * 60 * 24)) + '天前';
	}
	else if (milliseconds > 1000 * 60 * 60 * 24 * 15 && year == nowDate.getFullYear()) {
		timeSpanStr = month + '.' + day + ' ' + (hour < 10 ? `0${hour}` : hour) + ':' + (minute < 10 ? `0${minute}` : minute);
	} else {
		timeSpanStr = year + '-' + month + '-' + day;
	}
	return timeSpanStr;
}


function buildTree(value) {
	let list = JSON.parse(JSON.stringify(value));
	// let temp = {};
	let tree = [];
	list.forEach(item => {
		let temp = {};
		let children = {};
		temp.projectId = item.projectId;
		temp.projectName = item.projectName;
		temp.children = [];
		tree.push(temp)
	});
	let hash = {};
	tree = tree.reduce((item, next) => {
		hash[next.projectId] ? '' : hash[next.projectId] = true && item.push(next);
		return item;
	}, []);
	value.forEach((item) => {
		tree.forEach(items => {
			if (item.projectId === items.projectId) {
				// items.children=[];
				let children = {};
				children.tenantId = item.tenantId;
				children.projectId = item.projectId;
				children.tenantName = item.tenantName;
				children.remote = item.remote;
				items.children.push(children);
			}
		})
	})
	return tree;
}
//  base64解码
var Base64 = {
	// 转码表
	tables: [
		'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H',
		'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P',
		'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X',
		'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f',
		'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n',
		'o', 'p', 'q', 'r', 's', 't', 'u', 'v',
		'w', 'x', 'y', 'z', '0', '1', '2', '3',
		'4', '5', '6', '7', '8', '9', '+', '/'
	],
	UTF16ToUTF8: function (str) {
		let results = [], len = str.length;
		for (let i = 0; i < len; i++) {
			let code = str.charCodeAt(i);
			if (code > 0x0000 && code <= 0x007F) {
				/* 一字节，不考虑0x0000，因为是空字节
				   U+00000000 – U+0000007F 	0xxxxxxx
				*/
				results.push(str.charAt(i));
			} else if (code >= 0x0080 && code <= 0x07FF) {
				/* 二字节
				   U+00000080 – U+000007FF 	110xxxxx 10xxxxxx
				   110xxxxx
				*/
				let byte1 = 0xC0 | ((code >> 6) & 0x1F);
				// 10xxxxxx
				let byte2 = 0x80 | (code & 0x3F);
				results.push(
					String.fromCharCode(byte1),
					String.fromCharCode(byte2)
				);
			} else if (code >= 0x0800 && code <= 0xFFFF) {
				/* 三字节
				   U+00000800 – U+0000FFFF 	1110xxxx 10xxxxxx 10xxxxxx
				   1110xxxx
				*/
				let byte1 = 0xE0 | ((code >> 12) & 0x0F);
				// 10xxxxxx
				let byte2 = 0x80 | ((code >> 6) & 0x3F);
				// 10xxxxxx
				let byte3 = 0x80 | (code & 0x3F);
				results.push(
					String.fromCharCode(byte1),
					String.fromCharCode(byte2),
					String.fromCharCode(byte3)
				);
			} else if (code >= 0x00010000 && code <= 0x001FFFFF) {
				// 四字节
				// U+00010000 – U+001FFFFF 	11110xxx 10xxxxxx 10xxxxxx 10xxxxxx
			} else if (code >= 0x00200000 && code <= 0x03FFFFFF) {
				// 五字节
				// U+00200000 – U+03FFFFFF 	111110xx 10xxxxxx 10xxxxxx 10xxxxxx 10xxxxxx
			} else /** if (code >= 0x04000000 && code <= 0x7FFFFFFF)*/ {
				// 六字节
				// U+04000000 – U+7FFFFFFF 	1111110x 10xxxxxx 10xxxxxx 10xxxxxx 10xxxxxx 10xxxxxx
			}
		}

		return results.join('');
	},
	UTF8ToUTF16: function (str) {
		let results = [], len = str.length;
		let i = 0;
		for (let i = 0; i < len; i++) {
			let code = str.charCodeAt(i);
			// 第一字节判断
			if (((code >> 7) & 0xFF) == 0x0) {
				// 一字节
				// 0xxxxxxx
				results.push(str.charAt(i));
			} else if (((code >> 5) & 0xFF) == 0x6) {
				// 二字节
				// 110xxxxx 10xxxxxx
				let code2 = str.charCodeAt(++i);
				let byte1 = (code & 0x1F) << 6;
				let byte2 = code2 & 0x3F;
				let utf16 = byte1 | byte2;
				results.push(Sting.fromCharCode(utf16));
			} else if (((code >> 4) & 0xFF) == 0xE) {
				// 三字节
				// 1110xxxx 10xxxxxx 10xxxxxx
				let code2 = str.charCodeAt(++i);
				let code3 = str.charCodeAt(++i);
				let byte1 = (code << 4) | ((code2 >> 2) & 0x0F);
				let byte2 = ((code2 & 0x03) << 6) | (code3 & 0x3F);
				let utf16 = ((byte1 & 0x00FF) << 8) | byte2
				results.push(String.fromCharCode(utf16));
			} else if (((code >> 3) & 0xFF) == 0x1E) {
				// 四字节
				// 11110xxx 10xxxxxx 10xxxxxx 10xxxxxx
			} else if (((code >> 2) & 0xFF) == 0x3E) {
				// 五字节
				// 111110xx 10xxxxxx 10xxxxxx 10xxxxxx 10xxxxxx
			} else /** if (((code >> 1) & 0xFF) == 0x7E)*/ {
				// 六字节
				// 1111110x 10xxxxxx 10xxxxxx 10xxxxxx 10xxxxxx 10xxxxxx
			}
		}

		return results.join('');
	},
	encode: function (str) {
		if (!str) {
			return '';
		}
		let utf8 = this.UTF16ToUTF8(str); // 转成UTF-8
		let i = 0; // 遍历索引
		let len = utf8.length;
		let results = [];
		while (i < len) {
			let c1 = utf8.charCodeAt(i++) & 0xFF;
			results.push(this.tables[c1 >> 2]);
			// 补2个=
			if (i == len) {
				results.push(this.tables[(c1 & 0x3) << 4]);
				results.push('==');
				break;
			}
			let c2 = utf8.charCodeAt(i++);
			// 补1个=
			if (i == len) {
				results.push(this.tables[((c1 & 0x3) << 4) | ((c2 >> 4) & 0x0F)]);
				results.push(this.tables[(c2 & 0x0F) << 2]);
				results.push('=');
				break;
			}
			let c3 = utf8.charCodeAt(i++);
			results.push(this.tables[((c1 & 0x3) << 4) | ((c2 >> 4) & 0x0F)]);
			results.push(this.tables[((c2 & 0x0F) << 2) | ((c3 & 0xC0) >> 6)]);
			results.push(this.tables[c3 & 0x3F]);
		}

		return results.join('');
	},
	decode: function (str) {
		//判断是否为空
		if (!str) {
			return '';
		}

		let len = str.length;
		let i = 0;
		let results = [];
		//循环解出字符数组
		while (i < len) {
			let code1 = this.tables.indexOf(str.charAt(i++));
			let code2 = this.tables.indexOf(str.charAt(i++));
			let code3 = this.tables.indexOf(str.charAt(i++));
			let code4 = this.tables.indexOf(str.charAt(i++));

			let c1 = (code1 << 2) | (code2 >> 4);
			results.push(String.fromCharCode(c1));

			if (code3 != -1) {
				let c2 = ((code2 & 0xF) << 4) | (code3 >> 2);
				results.push(String.fromCharCode(c2));
			}
			if (code4 != -1) {
				let c3 = ((code3 & 0x3) << 6) | code4;
				results.push(String.fromCharCode(c3));
			}

		}

		return this.UTF8ToUTF16(results.join(''));
	}
}

// 解析参数
function getUrlParams(url, key) {
	// debugger
	// let url = url //获取url中"?"符后的字串
	let theRequest = {}
	url = "?" + url
	if (url.indexOf('?') != -1) {
		let str = url.substr(1)
		let strs = str.split('&')
		for (var i = 0; i < strs.length; i++) {
			theRequest[strs[i].split('=')[0]] = strs[i].split('=')[1]
		}
	}
	let value = theRequest[key] || ''
	return value
}

module.exports = {
	formatTime: formatTime,
	formatDate: formatDate,
	checkHasLocationPermissionByMP: checkHasLocationPermissionByMP,
	PrefixZero: PrefixZero,
	buildTree: buildTree,
	Base64: Base64,
	getUrlParams,
	picInit: picInit,
	formatMsgTime: formatMsgTime,
}